<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:27 CEST 2019 -->
<title>AuthenticationPlugin (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="AuthenticationPlugin (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.AuthStatus.html" title="enum in org.firebirdsql.gds.ng.wire.auth"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../../index.html?org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html" target="_top">Frames</a></li>
<li><a href="AuthenticationPlugin.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng.wire.auth</div>
<h2 title="Interface AuthenticationPlugin" class="title">Interface AuthenticationPlugin</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public interface <span class="typeNameLabel">AuthenticationPlugin</span></pre>
<div class="block">Plugin for Firebird authentication.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Interface and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.AuthStatus.html" title="enum in org.firebirdsql.gds.ng.wire.auth">AuthenticationPlugin.AuthStatus</a></span></code>
<div class="block">Status of authentication.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.AuthStatus.html" title="enum in org.firebirdsql.gds.ng.wire.auth">AuthenticationPlugin.AuthStatus</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#authenticate-org.firebirdsql.gds.ng.wire.auth.ClientAuthBlock-">authenticate</a></span>(<a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/ClientAuthBlock.html" title="class in org.firebirdsql.gds.ng.wire.auth">ClientAuthBlock</a>&nbsp;clientAuthBlock)</code>
<div class="block">Authenticate using the plugin.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#generatesSessionKey--">generatesSessionKey</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#getClientData--">getClientData</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#getName--">getName</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#getSessionKey--">getSessionKey</a></span>()</code>
<div class="block">Session key for encryption.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#hasServerData--">hasServerData</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#setServerData-byte:A-">setServerData</a></span>(byte[]&nbsp;serverData)</code>
<div class="block">Sets data received from the server.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getName--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getName</h4>
<pre><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getName()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Name of the plugin as used by Firebird</dd>
</dl>
</li>
</ul>
<a name="authenticate-org.firebirdsql.gds.ng.wire.auth.ClientAuthBlock-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>authenticate</h4>
<pre><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.AuthStatus.html" title="enum in org.firebirdsql.gds.ng.wire.auth">AuthenticationPlugin.AuthStatus</a>&nbsp;authenticate(<a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/ClientAuthBlock.html" title="class in org.firebirdsql.gds.ng.wire.auth">ClientAuthBlock</a>&nbsp;clientAuthBlock)
                                      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Authenticate using the plugin.
 <p>
 The data generated by this method should be stored and available for calls from <a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#getClientData--"><code>getClientData()</code></a>.
 </p>
 <p>
 The method authenticate may be called multiple times depending on the state of the authentication (as indicated
 by the returned <a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.AuthStatus.html" title="enum in org.firebirdsql.gds.ng.wire.auth"><code>AuthenticationPlugin.AuthStatus</code></a>.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>clientAuthBlock</code> - Client authentication block.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Status of the authentication</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For authentication failures</dd>
</dl>
</li>
</ul>
<a name="getClientData--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getClientData</h4>
<pre>byte[]&nbsp;getClientData()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The data generated by a call to <a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html#authenticate-org.firebirdsql.gds.ng.wire.auth.ClientAuthBlock-"><code>authenticate(ClientAuthBlock)</code></a>.</dd>
</dl>
</li>
</ul>
<a name="setServerData-byte:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setServerData</h4>
<pre>void&nbsp;setServerData(byte[]&nbsp;serverData)</pre>
<div class="block">Sets data received from the server.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>serverData</code> - Server data</dd>
</dl>
</li>
</ul>
<a name="hasServerData--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasServerData</h4>
<pre>boolean&nbsp;hasServerData()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if plugin has non-null and non-empty server data</dd>
</dl>
</li>
</ul>
<a name="generatesSessionKey--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>generatesSessionKey</h4>
<pre>boolean&nbsp;generatesSessionKey()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if the plugin generates a session key</dd>
</dl>
</li>
</ul>
<a name="getSessionKey--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getSessionKey</h4>
<pre>byte[]&nbsp;getSessionKey()
              throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Session key for encryption.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Session key</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If there is currently no session key or the authentication plugin doesn't support session key
         generation.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../../org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.AuthStatus.html" title="enum in org.firebirdsql.gds.ng.wire.auth"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../../index.html?org/firebirdsql/gds/ng/wire/auth/AuthenticationPlugin.html" target="_top">Frames</a></li>
<li><a href="AuthenticationPlugin.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
